#include "tetrimino.h"

// Order: ZLOSIJT

const u8 tetrimino_shape[7][4][16] = {
    {
        // Z
        {
            1, 1, 0, 0,
            0, 1, 1, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
        },
        {
            0, 0, 1, 0,
            0, 1, 1, 0,
            0, 1, 0, 0,
            0, 0, 0, 0,
        },
        {
            0, 0, 0, 0,
            1, 1, 0, 0,
            0, 1, 1, 0,
            0, 0, 0, 0,
        },
        {
            0, 1, 0, 0,
            1, 1, 0, 0,
            1, 0, 0, 0,
            0, 0, 0, 0,
        },
    },
    {
        // L
        {
            0, 0, 2, 0,
            2, 2, 2, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
        },
        {
            0, 2, 0, 0,
            0, 2, 0, 0,
            0, 2, 2, 0,
            0, 0, 0, 0,
        },
        {
            0, 0, 0, 0,
            2, 2, 2, 0,
            2, 0, 0, 0,
            0, 0, 0, 0,
        },
        {
            2, 2, 0, 0,
            0, 2, 0, 0,
            0, 2, 0, 0,
            0, 0, 0, 0,
        },
    },
    {
        // O
        {
            0, 3, 3, 0,
            0, 3, 3, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
        },
        {
            0, 3, 3, 0,
            0, 3, 3, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
        },
        {
            0, 3, 3, 0,
            0, 3, 3, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
        },
        {
            0, 3, 3, 0,
            0, 3, 3, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
        },
    },
    {
        // S
        {
            0, 4, 4, 0,
            4, 4, 0, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
        },
        {
            0, 4, 0, 0,
            0, 4, 4, 0,
            0, 0, 4, 0,
            0, 0, 0, 0,
        },
        {
            0, 0, 0, 0,
            0, 4, 4, 0,
            4, 4, 0, 0,
            0, 0, 0, 0,
        },
        {
            4, 0, 0, 0,
            4, 4, 0, 0,
            0, 4, 0, 0,
            0, 0, 0, 0,
        },
    },
    {
        // I
        {
            0, 0, 0, 0,
            5, 5, 5, 5,
            0, 0, 0, 0,
            0, 0, 0, 0,
        },
        {
            0, 0, 5, 0,
            0, 0, 5, 0,
            0, 0, 5, 0,
            0, 0, 5, 0,
        },
        {
            0, 0, 0, 0,
            0, 0, 0, 0,
            5, 5, 5, 5,
            0, 0, 0, 0,
        },
        {
            0, 5, 0, 0,
            0, 5, 0, 0,
            0, 5, 0, 0,
            0, 5, 0, 0,
        },
    },
    {
        // J
        {
            6, 0, 0, 0,
            6, 6, 6, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
        },
        {
            0, 6, 6, 0,
            0, 6, 0, 0,
            0, 6, 0, 0,
            0, 0, 0, 0,
        },
        {
            0, 0, 0, 0,
            6, 6, 6, 0,
            0, 0, 6, 0,
            0, 0, 0, 0,
        },
        {
            0, 6, 0, 0,
            0, 6, 0, 0,
            6, 6, 0, 0,
            0, 0, 0, 0,
        },
    },
    {
        // T
        {
            0, 7, 0, 0,
            7, 7, 7, 0,
            0, 0, 0, 0,
            0, 0, 0, 0,
        },
        {
            0, 7, 0, 0,
            0, 7, 7, 0,
            0, 7, 0, 0,
            0, 0, 0, 0,
        },
        {
            0, 0, 0, 0,
            7, 7, 7, 0,
            0, 7, 0, 0,
            0, 0, 0, 0,
        },
        {
            0, 7, 0, 0,
            7, 7, 0, 0,
            0, 7, 0, 0,
            0, 0, 0, 0,
        },
    },
};

const s8 tetrimino_kick[7][8 * 5][2] = {
    {
        // Z
        {0, 0}, {-1, 0}, {-1, 1}, {0, -2}, {-1, -2},
        {0, 0}, {1, 0}, {1, -1}, {0, 2}, {1, 2},
        {0, 0}, {1, 0}, {1, -1}, {0, 2}, {1, 2},
        {0, 0}, {-1, 0}, {-1, 1}, {0, -2}, {-1, -2},
        {0, 0}, {1, 0}, {1, 1}, {0, -2}, {1, -2},
        {0, 0}, {-1, 0}, {-1, -1}, {0, 2}, {-1, 2},
        {0, 0}, {-1, 0}, {-1, -1}, {0, 2}, {-1, 2},
        {0, 0}, {1, 0}, {1, 1}, {0, -2}, {1, -2},
    },
    {
        // L
        {0, 0}, {-1, 0}, {-1, 1}, {0, -2}, {-1, -2},
        {0, 0}, {1, 0}, {1, -1}, {0, 2}, {1, 2},
        {0, 0}, {1, 0}, {1, -1}, {0, 2}, {1, 2},
        {0, 0}, {-1, 0}, {-1, 1}, {0, -2}, {-1, -2},
        {0, 0}, {1, 0}, {1, 1}, {0, -2}, {1, -2},
        {0, 0}, {-1, 0}, {-1, -1}, {0, 2}, {-1, 2},
        {0, 0}, {-1, 0}, {-1, -1}, {0, 2}, {-1, 2},
        {0, 0}, {1, 0}, {1, 1}, {0, -2}, {1, -2},
    },
    {
        // O
        {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, 
        {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, 
        {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, 
        {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, 
        {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, 
        {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, 
        {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, 
        {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, 
    },
    {
        // S
        {0, 0}, {-1, 0}, {-1, 1}, {0, -2}, {-1, -2},
        {0, 0}, {1, 0}, {1, -1}, {0, 2}, {1, 2},
        {0, 0}, {1, 0}, {1, -1}, {0, 2}, {1, 2},
        {0, 0}, {-1, 0}, {-1, 1}, {0, -2}, {-1, -2},
        {0, 0}, {1, 0}, {1, 1}, {0, -2}, {1, -2},
        {0, 0}, {-1, 0}, {-1, -1}, {0, 2}, {-1, 2},
        {0, 0}, {-1, 0}, {-1, -1}, {0, 2}, {-1, 2},
        {0, 0}, {1, 0}, {1, 1}, {0, -2}, {1, -2},
    },
    {
        // I
        {0, 0}, {-2, 0}, {1, 0}, {-2, -1}, {1, 2},
        {0, 0}, {2, 0}, {-1, 0}, {2, 1}, {-1, -2},
        {0, 0}, {-1, 0}, {2, 0}, {-1, 2}, {2, -1},
        {0, 0}, {1, 0}, {-2, 0}, {1, -2}, {-2, 1},
        {0, 0}, {2, 0}, {-1, 0}, {2, 1}, {-1, -2},
        {0, 0}, {-2, 0}, {1, 0}, {-2, -1}, {1, 2},
        {0, 0}, {1, 0}, {-2, 0}, {1, -2}, {-2, 1},
        {0, 0}, {-1, 0}, {2, 0}, {-1, 2}, {2, -1},
    },
    {
        // J
        {0, 0}, {-1, 0}, {-1, 1}, {0, -2}, {-1, -2},
        {0, 0}, {1, 0}, {1, -1}, {0, 2}, {1, 2},
        {0, 0}, {1, 0}, {1, -1}, {0, 2}, {1, 2},
        {0, 0}, {-1, 0}, {-1, 1}, {0, -2}, {-1, -2},
        {0, 0}, {1, 0}, {1, 1}, {0, -2}, {1, -2},
        {0, 0}, {-1, 0}, {-1, -1}, {0, 2}, {-1, 2},
        {0, 0}, {-1, 0}, {-1, -1}, {0, 2}, {-1, 2},
        {0, 0}, {1, 0}, {1, 1}, {0, -2}, {1, -2},
    },
    {
        // T
        {0, 0}, {-1, 0}, {-1, 1}, {0, -2}, {-1, -2},
        {0, 0}, {1, 0}, {1, -1}, {0, 2}, {1, 2},
        {0, 0}, {1, 0}, {1, -1}, {0, 2}, {1, 2},
        {0, 0}, {-1, 0}, {-1, 1}, {0, -2}, {-1, -2},
        {0, 0}, {1, 0}, {1, 1}, {0, -2}, {1, -2},
        {0, 0}, {-1, 0}, {-1, -1}, {0, 2}, {-1, 2},
        {0, 0}, {-1, 0}, {-1, -1}, {0, 2}, {-1, 2},
        {0, 0}, {1, 0}, {1, 1}, {0, -2}, {1, -2},
    },
};